use super::{*, Sector, SectorWriter, {CDDesc, Error}};
use super::super::types::{layout::Layout, SystemArea};

pub fn encode_psx_image(cd_desc: CDDesc, sec_writer: &mut dyn SectorWriter) -> Result<(), Error> {
    for element in cd_desc.get_memory_layout() {
        match element {
            Layout::SystemArea(system_area) => process_system_area(&system_area.borrow(), sec_writer)?,
            _                               => ()
        }
    }

    Err(Error::not_implemented("encode_psx_image"))
}

fn process_system_area(system_area: &SystemArea, sec_writer: &mut dyn SectorWriter) -> Result<(), Error> {

    sec_writer.write(Sector::CDXAData(builder::create_xa_data_zero(system_area.properties.lba)))
}